#include <iostream>
#include <cstddef>

using namespace std;

void print_in_hex(uint8_t byte)
{
    printf("%02X ", byte);
}

void print_in_hex(const void* data, size_t size)
{
    const uint8_t* bytes = (const uint8_t*)data;
    for (size_t i = 0; i < size; i++)
    {
        print_in_hex(bytes[i]);
        if ((i + 1) % 8 == 0)
            printf("\n");
    }
    printf("\n");
}

void print_in_binary(uint8_t byte)
{
    for (int i = 7; i >= 0; i--)
    {
        printf("%d", (byte >> i) & 1);
        if (i % 8 == 0)
            printf(" ");
    }
}

void print_in_binary(const void* data, size_t size)
{
    const uint8_t* bytes = (const uint8_t*)data;
    for (size_t i = 0; i < size; ++i)
    {
        print_in_binary(bytes[i]);
        if ((i + 1) % 8 == 0)
            printf("\n");
    }
}

#pragma pack(1)
//  
struct Student 
{
    // 
    char _name[17];
    //  
    uint16_t _year;
    //  
    float _averageGrade;
    //  (0  , 1  )
    uint8_t _gender : 1;
    //   
    uint8_t _numCourses : 7;
    //    
    Student* _leader;
};
#pragma pack()

int main() 
{
    setlocale(LC_ALL, "Russian");
    Student students[3] = {0};

    //    
    strcpy(students[0]._name, "");
    students[0]._year = 2020;
    students[0]._averageGrade = 4.9f;
    students[0]._gender = 0;
    students[0]._numCourses = 7;
    students[0]._leader = nullptr;

    //     
    strcpy(students[1]._name, "");
    students[1]._year = 2020;
    students[1]._averageGrade = 4.5f;
    students[1]._gender = 1;
    students[1]._numCourses = 5;
    students[1]._leader = &students[0];

    //     
    strcpy(students[2]._name, "");
    students[2]._year = 2021;
    students[2]._averageGrade = 4.8f;
    students[2]._gender = 1;
    students[2]._numCourses = 6;
    students[2]._leader = &students[0];

    //     
    cout << " : " << &students << endl;
    cout << " : " << sizeof(students) << " " << endl;

    //       
    for (int i = 0; i < 3; i++) 
    {
        cout << "  " << i << ": " << &students[i] << endl;
        cout << "  " << i << ": " << sizeof(students[i]) << " " << endl;
    }

    //         ( )
    int index = 1;
    Student& student = students[index];
    cout << "   " << index << ":" << endl;
    cout << "  _name: " << student._name << endl;
    cout << "  _name: " << &(student._name) << endl;
    cout << "  _name   : " << offsetof(Student, _name) << " " << endl;
    cout << "  _name: " << sizeof(student._name) << " " << endl;
    cout << "   _name:" << endl;
    print_in_hex(student._name, sizeof(student._name));
    cout << "   _name:" << endl;
    print_in_binary(student._name, sizeof(student._name));
    cout << endl;

    cout << "    :" << endl;
    cout << "( " << sizeof(student._name) << "  -  _name):" << endl;
    cout << "( " << sizeof(student._year) << "  -  _year):" << endl;
    cout << "( " << sizeof(student._averageGrade) << "  -  _averageGrade):" << endl;
    cout << "( " << sizeof(uint8_t) << "  - 1   _gender  7   _numCourses):" << endl;
    cout << "( " << sizeof(student._leader) << "  -  _leader):" << endl;
    for (int i = 0; i < 3; i++)
    {
        cout << "   " << i << endl;
        print_in_hex(&students[i], sizeof(students[i]));
    }

    system("pause");
    return 0;
}